=begin
------------------------------------------------------------------------
Copyright 2007, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
------------------------------------------------------------------------
Name        : Roof.rb
Author      : TIG
Description : A set of Roof Making Tools.
Menu Item   : Plugins > Roof... > Sub-Menus...
Usage       : See RoofHelp.mht file originally distributed with this.
Version     : 1.0	20070824	First issue.
			  1.1	20070826	A:B slope glitch fixed: array.to_f !
			  1.2	20070827	Rectangle checking OK =~ 90 degrees.
------------------------------------------------------------------------
=end
eval %q{PWJlZ2luCi0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t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}.unpack("m").to_s